;******************************************************************************
;* Projekt neve: Kigyo jatek                                                  *
;* Projekt verzi: 0.9.1                                                      *
;* Projekt lersa :                                                          *
;* Az els Nokia mobiltelefonokban megismert kgyjtk msolata              *
;* annyi eltrssel, hogy tbb plya van s nem n a kgy mrete             *
;*                                                                            *
;* Fejlesztk: Majdn Andrs, Porohnavec Jzsef                               *
;* Labor csoport: I1PDU05                                                     *
;* Utols mdosts: 2006/11/20 22:00                                         *
;******************************************************************************

;******************************************************************************
;* "AVR ExperimentBoard" port assignment information:                         *
;******************************************************************************
;*                                                                            *
;* LED0(P):PortC.0          LED4(P):PortC.4                                   *
;* LED1(P):PortC.1          LED5(P):PortC.5                                   *
;* LED2(S):PortC.2          LED6(S):PortC.6                                   *
;* LED3(Z):PortC.3          LED7(Z):PortC.7        INT:PortE.4                *
;*                                                                            *
;* SW0:PortG.0     SW1:PortG.1     SW2:PortG.4     SW3:PortG.3                *
;*                                                                            *
;* BT0:PortE.5     BT1:PortE.6     BT2:PortE.7     BT3:PortB.7                *
;*                                                                            *
;******************************************************************************
;*                                                                            *
;* AIN:PortF.0     NTK:PortF.1    OPTO:PortF.2     POT:PortF.3                *
;*                                                                            *
;******************************************************************************
;*                                                                            *
;* LCD1(VSS) = GND         LCD9(DB2): -                                       *
;* LCD2(VDD) = VCC         LCD10(DB3): -                                      *
;* LCD3(VO ) = GND         LCD11(DB4): PortA.4                                *
;* LCD4(RS ) = PortA.0     LCD12(DB5): PortA.5                                *
;* LCD5(R/W) = GND         LCD13(DB6): PortA.6                                *
;* LCD6(E  ) = PortA.1     LCD14(DB7): PortA.7                                *
;* LCD7(DB0) = -           LCD15(BLA): VCC                                    *
;* LCD8(DB1) = -           LCD16(BLK): PortB.5 (1=Backlight ON)               *
;*                                                                            *
;******************************************************************************

;******************************************************************************
;*
;*  Frissteni a modelt a programkd alapjn
;*  TODO
;*
;* Adatmemria
;* 
;* Jells 
;* $1,$2
;*
;*  $1 A memria Hi cme
;*  $2 A memria Lo cme
;* 
;* 1,0-1,132 A kigy s plyja
;* 
;*  x 0123456789012345678901
;* y
;* 0  ffffffffffffffffffffff
;* 1  f....................f
;* 2  f..........xxxxx.....f
;* 3  f....................f
;* 4  f....................f
;* 5  ffffffffffffffffffffff
;* 
;* 1,133 A pontok szma
;* 1,134 Az irny amerre a kgy tart
;* 
;*   4
;* 3 0 1
;*   2
;* 
;* 1,135 A kigy hossza
;* 1,136-1,186 A kgy testnek tmbje (max 50 elem)
;* 
;*    0123456789
;* 
;* 0  ffffffffff
;* 1  f.xxxxx...
;* 2  f.........
;* 
;* 25,26,27,28 ($1)
;* 
;* A koordintk minden esetben relatv memria cmek
;* a plya kezdeti memria cmhez (1,$1)
;******************************************************************************

.include "m128def.inc" ; ATmega128 defincis fjl 

;******************************************************************************
;*                                                                            *
;*  Konstansok                                                                *
;*  Nevestett konstansok az egyszer programozshoz s az tlthatsghoz    *
;*                                                                            *
;******************************************************************************

.equ	lcdrs =0	;LCD RS pin connected to PortA0
.equ	lcden =1	;LCD E pin connected to PortA1

.equ	LineLength=20
.equ	NoOfLines=4


.equ	FirstLine_Add =0b10000000 ;Base address of first line for 2x16 lcd
.equ	SecondLine_Add=0b11000000 ;+40 Base address of second line
.equ	ThirdLine_Add =0b10010100 ;+14 Base address of 3.line 
.equ	FourthLine_Add=0b11010100 ;+54 Base address of 4.line



; Plya kezdete a memriban
.equ PALYA_H    = 1
.equ PALYA_L    = 0

; A pontszm hol helyezkedik el a memriban
.equ PONTOK_H   = 1
.equ PONTOK_L   = 133

; Az irny hol helyezkedik el a memriban
.equ IRANY_H    = 1
.equ IRANY_L    = 134

; A kigy hossza hol helyezkedik el a memriban
.equ HOSSZ_H    = 1
.equ HOSSZ_L    = 135

; A kgy testnek elemei hol kezddnek a memriban
.equ KIGYO_H    = 1
.equ KIGYO_L    = 136

; A GOMB1/2/3/4 sajt memria cmei, ahol troldik llapotuk
.equ GOMB1_H = 1
.equ GOMB1_L = 187
.equ GOMB2_H = 1
.equ GOMB2_L = 188
.equ GOMB3_H = 1
.equ GOMB3_L = 189
.equ GOMB4_H = 1
.equ GOMB4_L = 190

; Hnyadik plyn vagyunk
.equ PALYASZAM_H = 1 
.equ PALYASZAM_L = 191

; Van-e mr a plyn ajndk
.equ AJANDEK_H  = 1
.equ AJANDEK_L  = 192

; Honnan indul a kgy
.equ START      = 46

; A plyaelemek bjt megfeleli
.equ FAL        = 255
.equ KAJA       = '*'
.equ URES       = ' '
.equ KIGYO      = '@'

; A minusz szmok hatra, ahol eljeles rtkek szksgesek
.equ MINUSZ     = 127

; A kgy jtk zenet hol helyezkedik el
.equ KIGYO_UZENET_H = 1
.equ KIGYO_UZENET_L = 23

; A plya vlaszts hol helyezkedik el
.equ PALYA_UZENET_H = 1
.equ PALYA_UZENET_L = 45

; A jtk vge zenet hol helyezkedik el
.equ VEGE_UZENET_H  = 1
.equ VEGE_UZENET_L  = 23 

;******************************************************************************
;*                                                                            *
;*  Regiszterek                                                               *
;*  A regiszterek elnevestse, hasznlatnak definilsa                     *
;*                                                                            *
;******************************************************************************

.def mari =  r16    ; A 'mari' regiszter, ami mindent elvgez
.def bela =  r17    ; A 'bela' regiszter, ami elvgzi azt amit a 'mari' nem :)
.def cecil = r14    ; A 'cecil' regiszter klnleges esetekre

; Ugyanazok a regiszterek, de csak megszaktsban val hasznlatra
.def imari  = r19
.def ibela  = r11
.def icecil = r10

; Vletlenszm generlshoz
.def rmari = r13


.def	wreg	=R18	;General use working register
.def	tmp1	=r20
.def	tmp2	=R21
.def	DataReg	=r22
.def	LCD_X	=r23
.def	LCD_Y	=r24

.def	CmdReg	=R25

.def	Line_Wrap=r12	;0 = No line wrap 1= Wrap to next line when reach last xpos

;******************************************************************************
;*                                                                            *
;* Megszakts tbla                                                          *
;*                                                                            *
;******************************************************************************
.cseg       ; Kd szegmensz
.org $0000  ; Kd kezdete 

    ; Megszaktsok elhelyezse s inicializlsa
    ; TODO

        jmp RESET ; jraindts 
		jmp		dummy		; EXTINT0 Handler
		jmp		dummy		; EXTINT1 Handler
		jmp		dummy		; EXTINT2 Handler
		jmp		dummy		; EXTINT3 Handler
		jmp		GOMB4		; EXTINT4 Handler (INT gomb)
		jmp		GOMB1		; EXTINT5 Handler
		jmp		GOMB3		; EXTINT6 Handler
		jmp		GOMB2		; EXTINT7 Handler
		jmp		dummy		; Timer2 Compare Match Handler 
		jmp		dummy		; Timer2 Overflow Handler 
		jmp		dummy		; Timer1 Capture Event Handler 
		jmp		dummy		; Timer1 Compare Match A Handler 
		jmp		dummy		; Timer1 Compare Match B Handler 
		jmp		dummy		; Timer1 Overflow Handler 
		jmp		dummy		; Timer0 Compare Match Handler 
		jmp		dummy		; Timer0 Overflow Handler 
		jmp		dummy		; SPI Transfer Complete Handler 
		jmp		dummy		; USART0 RX Complete Handler 
		jmp		dummy		; USART0 Data Register Empty Hanlder 
		jmp		dummy		; USART0 TX Complete Handler 
		jmp		dummy		; ADC Conversion Complete Handler 
		jmp		dummy		; EEPROM Ready Hanlder 
		jmp		dummy		; Analog Comparator Handler 
		jmp		dummy		; Timer1 Compare Match C Handler 
		jmp		dummy		; Timer3 Capture Event Handler 
		jmp		dummy		; Timer3 Compare Match A Handler 
		jmp		dummy		; Timer3 Compare Match B Handler 
		jmp		dummy		; Timer3 Compare Match C Handler 
		jmp		dummy		; Timer3 Overflow Handler 
		jmp		dummy		; USART1 RX Complete Handler 
		jmp		dummy		; USART1 Data Register Empty Hanlder 
		jmp		dummy		; USART1 TX Complete Handler 
		jmp		dummy		; Two-wire Serial Interface Handler 
		jmp		dummy		; Store Program Memory Ready Handler 

;******************************************************************************
;*                                                                            *
;*  Markk                                                                    *
;*  A kd tlthatsgt s az egyszerbb programozst segt makrk          *
;*                                                                            *
;******************************************************************************

;*** Push immediate ********************
;*                                     *                                       
;* A paramtert a stackbe lenyomja     *
;* (regiszterbe helyezi eltte)        *       
;*                                     *                                          
;* rintett regiszterek                *                                          
;* mari                                *                                          
;*                                     *                                          
;***************************************
.MACRO pushi
        ldi mari, @0    ; 1. paramter betltse a 'mari' regiszterbe
        push mari       ; Lenyomja a stackbe a regiszter rtkt
.ENDMACRO

;*** Push word immediate ***************
;*                                     *
;* A word tpus paramtert a stackbe  *
;* lenyomja (ellte regiszterbe teszi) *
;*                                     *
;* rintett regiszterek                *
;* mari                                *
;*                                     *
;***************************************
.MACRO wpushi
        ldi mari, @0    ; 1. paramter betltse a 'mari' regiszterben
        push mari       ; Lenyomja a stackbe a regiszter rtkt
        ldi mari, @1    ; 2. paramter betltse a 'mari' regiszterben
        push mari       ; Lenyomja a stackbe a regiszter rtkt
.ENDMACRO 

;*** Store immediate *******************
;*                                     *
;* A paramtert a memria megfelel    *
;* cmre msolja                      *
;*                                     *
;* rintett regiszterek                *
;* Y,mari                              *
;*                                     *
;***************************************
.MACRO sti
        ldi yh, @0      ; A cmz regiszter fels bjtjt belltja
        ldi yl, @1      ; A cmz regiszter als bjtjt belltja
        ldi mari, @2    ; A bjtot, amit rni kell regiszterbe helyezi
        st y, mari      ; Memriba r
.ENDMACRO


;*** Store immediate in interrupt ******
;*                                     *
;* A paramtert a memria megfelel    *
;* cmre msolja                      *
;* MEGSZAKTSBAN VAL HASZNLATRA     *
;*                                     *
;* rintett regiszterek                *
;* imari, ibela, icecil                *
;*                                     *
;***************************************
.MACRO stii
        mov ibela, yh   ; Y fels bjtjnak megrzse
        mov icecil, yl  ; Y als bjtjnak megrzse
        ldi yh, @0      ; A cmz regiszter fels bjtjt belltja
        ldi yl, @1      ; A cmz regiszter als bjtjt belltja
        ldi imari, @2   ; A bjtot, amit rni kell regiszterbe helyezi
        st y, imari     ; Memriba r
        mov yh, ibela   ; Y fels bjtjnak visszalltsa 
        mov yl, icecil  ; Y als bjtjnak visszalltsa 
.ENDMACRO


    
;******************************************************************************
;*                                                                            *
;* Inicializci                                                              *
;* Mindent a kezdeti rtkre llt                                            *
;*                                                                            *
;******************************************************************************
.org $0046      ; A program helye a kdmemriban
M_INIT:
RESET: 
    ; Stack belltsa a RAM vgre
    ldi mari, LOW(RAMEND) ; RAMEND = maximlis cm a RAM-ban, ami
    out SPL, mari         ; RAMEND   az "m128def.inc" fjlban van definilva 
    ldi mari, HIGH(RAMEND) 
    out SPH, mari

	ldi	mari,0x00	;PORTA Low
	out	PORTA,mari
	ldi	mari,0xFF	;Make port A pin all outputs
	out	DDRA,mari

	ldi	mari,0xff	;PORTB Hi
	out	PORTB,mari
	ldi	mari,0x80	;Make port B7 out, others input
	out	DDRB,mari

	ldi	mari,0x00	;PORTC Low
	out	PORTC,mari
	ldi	mari,0xFF	;Make port C pin all outputs
	out	DDRC,mari

	ldi	mari,0xff	;PORTE Hi
	out	PORTE,mari
	ldi	mari,0x01	;Make port E0 out, others input
	out	DDRE,mari

	ldi	mari,0xff	;PORTG Hi
	sts	PORTG,mari
	ldi	mari,0x00	;Make port G pin all input
	sts	DDRG,mari

	ldi mari, 0b10000000  ; interrupt lenyomsra
    out EICRB, mari
    ldi mari, 0b10000000  ; BT2 interruptolhat
    ldi mari, 255  ; BT2 interruptolhat
    out EIMSK, mari
    sei                   ; interruptok engedlyezse

	; LCD KOD
	;init others
	ldi mari, 0
	mov	Line_Wrap,mari	;0 = No line wrap 1= Wrap to next line when reach last xpos
	call	Lcd_Init	;Init the LCD
	rcall LCD_CursorOFF

	rcall	Delay1s		; Wait 1 sec


    ; Sajt kijelz puffer tiszttsa
    pushi URES                      ; res karakterrel tlti fel a memrit
    wpushi PALYA_H, PALYA_L + 0     ; Kezdcm H,L bjt
    wpushi PALYA_H, PALYA_L + 132   ; Vgcm H,L bjt
    call MEMORIA_KITOLTES           ; Memria kitltse  

    ; Gombok llapotnak alapbelltsa a memriban
    sti GOMB1_H, GOMB1_L, 0
    sti GOMB2_H, GOMB2_L, 0
    sti GOMB3_H, GOMB3_L, 0
    sti GOMB4_H, GOMB4_L, 0

    ; Az eddig szerzett pontok nullzsa
    sti PONTOK_H,PONTOK_L, 0

    ; Nincs mg ajndk a plyn
    sti AJANDEK_H,AJANDEK_L, 0

;******************************************************************************
;*                                                                            *
;* Alkalmazs log                                                            *
;* Az alkalmazs logjnak kirsa                                            *
;*                                                                            *
;******************************************************************************
ALKALMAZAS_LOGO:

    ; "kigyo jatek" felirat kiratsa
    pushi 0                 ; Szveg vgt jelz null bjt
    pushi 'k'
    pushi 'e'
    pushi 't'
    pushi 'a'
    pushi 'j'
    pushi URES              ; Szkz
    pushi 'o'
    pushi 'y'
    pushi 'g'
    pushi 'i'
    pushi 'K'
    pushi KIGYO_UZENET_L    ; A hely ahov ki kell rni a memriban
    pushi KIGYO_UZENET_H
    call UZENET             ; zenetet kir funkci meghvsa
    
;******************************************************************************
;*                                                                            *
;* Plya vlaszts                                                            *
;* A plya kivlasztst vgz kdrsz                                        *
;*                                                                            *
;******************************************************************************
PALYA_VALASZTAS:

    ; "palyak" felirat s a lehetsges vlasztsok kiratsa
    pushi 0                 ; Szveg vgt jelz null bjt
    pushi 'z'
    pushi 'e'
    pushi 'h'
    pushi 'e'
    pushi 'n'
    pushi URES
    pushi '3'
    pushi 13
    pushi 'l'
    pushi 'a'
    pushi 'm'
    pushi 'r'
    pushi 'o'
    pushi 'n'
    pushi URES
    pushi '2'
    pushi 13
    pushi 'u'
    pushi 'y'
    pushi 'n'
    pushi 'n'
    pushi 'o'
    pushi 'k'
    pushi URES
    pushi '1'
    pushi PALYA_UZENET_L    ; A hely ahov ki kell rni a memriban
    pushi PALYA_UZENET_H
    call UZENET             ; zenetet kir funkci meghvsa

    call LCD_KIIRAS         ; Kirom a memrit az LCD kijelzre

    ; Vrakozs egy megszaktsa (valamelyik gombot lenyomjk)
    VARAKOZAS_VALASZTASRA:
        ; Lssuk az els gombot nyomtk-e meg
        ldi yh, GOMB1_H     ; GOMB1 sajt trol cmnek belltsa
        ldi yl, GOMB1_L
        ld mari, y          ; Bjt olvassa (gomb llapota)
        cpi mari, 1         ; Be van-e nyomva a gomb
        breq PALYA_1        ; Igen, akkor ugorj az els plyra
    
        ; Lssuk a msodik gombot nyomtk-e meg
        ldi yh, GOMB3_H
        ldi yl, GOMB3_L
        ld mari, y
        cpi mari, 1
        breq PALYA_2

        ; Lssuk a harmadik gombot nyomtk-e meg
        ldi yh, GOMB2_H
        ldi yl, GOMB2_L
        ld mari, y
        cpi mari, 1
        breq PALYA_3
    jmp VARAKOZAS_VALASZTASRA   ; Nem nyomtak le gombot, jra ellenriz

    ; Els plya lett vlasztva
    PALYA_1:
        ldi yh, PALYASZAM_H     ; Plyaszm cme a memriban
        ldi yl, PALYASZAM_L
        ldi mari, 1             ; Els plya lesz
        st y, mari              ; Trols a memriban
        jmp ALAP_PALYA          ; Alap plya kirajzolsra ugrs

    ; Msodik plya lett vlasztva
    PALYA_2:
        ldi yh, PALYASZAM_H     ; Plyaszm cme a memriban
        ldi yl, PALYASZAM_L
        ldi mari, 2             ; Msodik plya lesz
        st y, mari              ; Trols a memriban
        jmp ALAP_PALYA          ; Alap plya kirajzolsra ugrs

    ; Harmadik plya lett vlasztva
    PALYA_3:
        ldi yh, PALYASZAM_H     ; Plyaszm cme a memriban
        ldi yl, PALYASZAM_L
        ldi mari, 3             ; Harmadik plya lesz
        st y, mari              ; Trols a memriban
        jmp ALAP_PALYA          ; Alap plya kirajzolsra ugrs

;******************************************************************************
;*                                                                            *
;* Plya kirajzols                                                           *
;* A plya kirajzolst vgz kdrsz                                         *
;*                                                                            *
;******************************************************************************
    ALAP_PALYA:

    ; Fels fal kitltse
    pushi FAL                       ; f karakterrel tlti fel a memrit
    wpushi PALYA_H, PALYA_L + 0     ; Kezdcm H,L bjt
    wpushi PALYA_H, PALYA_L + 22    ; Vgcm H,L bjt
    call MEMORIA_KITOLTES           ; Memria kitltse

    ; Bels plya 1.sora
    sti PALYA_H, PALYA_L + 22, FAL  ; 1.fal kezdeti eleme
    sti PALYA_H, PALYA_L + 43, FAL  ; 1.fal vg eleme
    pushi URES                      ; f karakterrel tlti fel a memrit
    wpushi PALYA_H, PALYA_L + 23    ; Kezdcm H,L bjt
    wpushi PALYA_H, PALYA_L + 43    ; Vgcm H,L bjt
    call MEMORIA_KITOLTES           ; Memria kitltse

    ; Bels plya 2.sora
    sti PALYA_H, PALYA_L + 44, FAL  ; 1.fal kezdeti eleme
    sti PALYA_H, PALYA_L + 65, FAL  ; 1.fal vg eleme
    pushi URES                      ; f karakterrel tlti fel a memrit
    wpushi PALYA_H, PALYA_L + 45    ; Kezdcm H,L bjt
    wpushi PALYA_H, PALYA_L + 65    ; Vgcm H,L bjt
    call MEMORIA_KITOLTES           ; Memria kitltse

    ; Bels plya 3.sora
    sti PALYA_H, PALYA_L + 66, FAL  ; 1.fal kezdeti eleme
    sti PALYA_H, PALYA_L + 87, FAL  ; 1.fal vg eleme
    pushi URES                      ; f karakterrel tlti fel a memrit
    wpushi PALYA_H,67               ; Kezdcm H,L bjt
    wpushi PALYA_H,87               ; Vgcm H,L bjt
    call MEMORIA_KITOLTES           ; Memria kitltse

    ; Bels plya 4.sora
    sti PALYA_H, PALYA_L + 88, FAL  ; 1.fal kezdeti eleme
    sti PALYA_H, PALYA_L + 109, FAL ; 1.fal vg eleme
    pushi URES                      ; f karakterrel tlti fel a memrit
    wpushi PALYA_H, PALYA_L + 89    ; Kezdcm H,L bjt
    wpushi PALYA_H, PALYA_L + 109   ; Vgcm H,L bjt
    call MEMORIA_KITOLTES           ; Memria kitltse

    ; Als fal kitltse
    pushi FAL               ; f karakterrel tlti fel a memrit
    wpushi PALYA_H, PALYA_L + 110           ; Kezdcm H,L bjt
    wpushi PALYA_H, PALYA_L + 132           ; Vgcm H,L bjt
    call MEMORIA_KITOLTES   ; Memria kitltse

    ; Nzzk knny plyt vlasztottak-e
    ldi yh, PALYASZAM_H     ; Plyaszm cme
    ldi yl, PALYASZAM_L
    ld mari, y              ; Regiszterbe tltm
    cpi mari, 1             ; Lssuk az els plya-e
    breq KIGYO_KIRAJZOLASA  ; Ha igen, akkor mr rajzolhatom a kgyt

    ; Nem az els plya, ezrt mr rajzolhatom a pluss falakat
    ; Norml plyhoz tartoz plussz falak
    sti PALYA_H, PALYA_L + 27, FAL
    sti PALYA_H, PALYA_L + 60, FAL
    sti PALYA_H, PALYA_L + 82, FAL
    sti PALYA_H, PALYA_L + 93, FAL

    ; Nzzk nehz plyt vlasztottak-e
    ldi yh, PALYASZAM_H     ; Plyaszm cme
    ldi yl, PALYASZAM_L
    ld mari, y              ; Regiszterbe tltm
    cpi mari, 3             ; Lssuk a nehz plya-e
    brne KIGYO_KIRAJZOLASA  ; Ha nem, akkor mr rajzolhatom a kgyt

    ; Nehz plyhoz tartoz plussz falak
    sti PALYA_H, PALYA_L + 26, FAL
    sti PALYA_H, PALYA_L + 28, FAL
    sti PALYA_H, PALYA_L + 57, FAL
    sti PALYA_H, PALYA_L + 58, FAL
    sti PALYA_H, PALYA_L + 59, FAL
    sti PALYA_H, PALYA_L + 81, FAL
    sti PALYA_H, PALYA_L + 83, FAL
    sti PALYA_H, PALYA_L + 84, FAL
    sti PALYA_H, PALYA_L + 92, FAL
    sti PALYA_H, PALYA_L + 94, FAL

;******************************************************************************
;*                                                                            *
;* A kgy kirajzolsa                                                        *
;* A plya kirajzolst vgz kdrsz                                         *
;*                                                                            *
;******************************************************************************
KIGYO_KIRAJZOLASA:

   	cli
	ldi mari, 255
	out EIFR, mari
	sei

	rcall delay100ms

	    ; Gombok llapotnak alapbelltsa a memriban
    sti GOMB1_H, GOMB1_L, 0
    sti GOMB2_H, GOMB2_L, 0
    sti GOMB3_H, GOMB3_L, 0
    sti GOMB4_H, GOMB4_L, 0

    ; Az irny amerre a kgy tart
    sti IRANY_H,IRANY_L, 1      ; Jobbra

    ; A kgy hossza
    sti HOSSZ_H,HOSSZ_l, 4      ; 4 hossz a kgy alapbl

    ; A kgy testnek elemei
    sti KIGYO_H, KIGYO_L, START + 3     ; Kgy eleje
    sti KIGYO_H, KIGYO_L + 1, START + 2 ; Kgy teste
    sti KIGYO_H, KIGYO_L + 2, START + 1 ; Kgy teste
    sti KIGYO_H, KIGYO_L + 3, START     ; Kgy farka

    ; A kigy testnnek kirajzolsa
    sti 1, START, KIGYO
    sti 1, START + 1, KIGYO
    sti 1, START + 2, KIGYO
    sti 1, START + 3, KIGYO

    call LCD_KIIRAS ; Kirajzolom a plyt az LCD kijelzre

;******************************************************************************
;*                                                                            *
;*  A jtk                                                                   *
;*                                                                            *
;*  A jtk maga, a kgy mozgatsa                                           *
;*                                                                            *
;******************************************************************************

JATEK:
    ; Merre tart a kgy
    lds mari, IRANY_H*256+IRANY_L
    ; A kigy fejnek koordinitja
    lds bela, KIGYO_H*256+KIGYO_L

    ; A 16 bites X regiszterbe kerl a kigy fejnek cme a plyn
    ldi xh, PALYA_H
    mov  xl, bela

    ; Merre is kell mozognia, a szelekci
    cpi mari, 1
    breq MOZGAT_JOBBRA
    cpi mari, 2
    breq MOZGAT_LE
    cpi mari, 3
    breq MOZGAT_BALRA
    cpi mari, 4
    breq MOZGAT_FEL

    ; Nem kell mozognia, azaz a programfutst szneteltetik (nincs idzts)
    jmp JATEK   ; Ugorj vissza az elejre s ellenrizz

    ; Jobbra kell mozgatni a kgyt
    MOZGAT_JOBBRA:
        ldi bela, 1     ; Jobbra mozgats vektor
        inc xl          ; Nvelem a cmz regisztert
        jmp MOZGAT_FO   ; Ugorj a f mozgat kdra

    ; Lefele kell mozgatni a kgyt
    MOZGAT_LE:
        ldi bela, 22    ; Jobbra mozgats vektor
        add xl, bela    ; Nvelem a cmz regisztert
        jmp MOZGAT_FO   ; Ugorj a f mozgat kdra

    ; Balra kell mozgatni a kgyt
    MOZGAT_BALRA:
        ldi bela, MINUSZ + 1    ; Negatv mozgs vektor
        dec xl                  ; Cskkentem a cmz regisztert
        jmp MOZGAT_FO           ; Ugorj a f mozgat kdra

    ; Felfele kell mozgatni a kgyt
    MOZGAT_FEL:
        ldi bela, 22            ; Ideiglenes mozgs vektor
        sub xl, bela            ; Cskkentem a cmzregisztert
        ldi bela, MINUSZ + 22   ; Negatv mozgs vektor
        jmp MOZGAT_FO           ; Ugorj a f mozgat kdra

    ; F mozgat kd
    MOZGAT_FO:

    ; Megnzem nem-e megy falnak
    ld  mari, x     ; Betltm az eltte tallhat karaktert

    ; res-e a hely
    cpi mari, URES
    breq M_J_NullOK ; Igen, ezrt mehetnk tovbb
    cpi mari, KAJA  ; Kaja van-e elttnk
    breq M_J_KajaOK ; Igen, ezrt mehetnk tovbb

    ; Falnak vagy nmagnak tkztt
    
    ; Megnzem nem-e a kgy utols eleme van elttnk, ami el fog mozdulni
    ldi zh, KIGYO_H     ; Kigy vgnek cme
    ldi zl, KIGYO_L+3
    ld mari, z          ; Beltm az ott talhat koordintt
    cp  mari, xl        ; Egyezik-e azzal ahov lpek
    breq M_J_NullOK     ; Egyezik, ezrt ugrs tovbb
    
    ; Nem egyezik, tkztem, vge a jtknak, ugrs oda
    jmp JATEK_VEGE
    
    ; Rendben van, kaja van elttnk 
    M_J_KajaOK:
    ldi yh, PONTOK_H    ; Pontok cme
    ldi yl, PONTOK_L
    ld mari, y          ; Jelenlegi pontszm lekrse
    inc mari            ; Pontszm nvelse
    st y, mari          ; Pontszm mentse
    sti AJANDEK_H, AJANDEK_L, 0     ; Ajndk mr nincs a plyn    

    ; Rendben van, nincs semmi elttnk
    M_J_NullOK:

    ; Kgy vgt letrlm
    lds mari, KIGYO_H*256+KIGYO_L+3
    mov xl, mari        ; Cmz regiszter belltsa 
    ldi xh, PALYA_H
    ldi mari, URES      ; res karakter
    st x, mari          ; Memriba rs

    ; Kgy elemeit rotlom a tmbben
    lds mari, KIGYO_H*256+KIGYO_L+2
    sts KIGYO_H*256+KIGYO_L+3, mari
    lds mari, KIGYO_H*256+KIGYO_L+1
    sts KIGYO_H*256+KIGYO_L+2, mari
    lds mari, KIGYO_H*256+KIGYO_L
    sts KIGYO_H*256+KIGYO_L+1, mari

    ; A mozgs irnynak vektora pozitv vagy negatv
    cpi bela, MINUSZ
    brlo M_POZITIV  ; Pozitv, ugrs oda

    ; Negatv a vektor, visszafele vagy felfele mozgs
    ldi mari, MINUSZ
    sub bela, mari  ; Kivonom a mnusz eljelet, hogy megkapjam a vektort
    lds mari, KIGYO_H*256+KIGYO_L   ; Jelenlegi hely lekrdezse
    sub mari, bela  ; Kivonom a jelenlegi helybl
    jmp M_TOVABB    ; Mehet tovbb a mozgs

    ; Pozitv a vektor, jobbra vagy lefele mozgs
    M_POZITIV:
    lds mari, KIGYO_H*256+KIGYO_L   ; Betltm a jelenlegi helyzetet
    add mari, bela  ; Hozzaadom a mozgsi vektort

    ; Kgy mozgsa mehet tovbb
    M_TOVABB:
    sts KIGYO_H*256+KIGYO_L, mari   ; Trolom a fejnek az j helyzett

    mov xl, mari        ; Kirajzolom a kgy j elemt
    ldi xh, PALYA_H     ; Cmregiszter kitltse
    ldi mari, KIGYO     ; Kgy testnek karaktere
    st x, mari          ; Berom a memriba
    
    inc rmari   ; Vletlen szm generlshoz

    ; Ajndk elhelyezse, ha nincs a plyn
    ldi xh, AJANDEK_H   ; Ajndk cme
    ldi xl, AJANDEK_L
    ld mari, x          ; Ajndk rtke
    cpi mari, 1         ; Van-e ajndk
    breq JATEK_TOVABB   ; Van, ugorhatunk tovbb

    ; Nincs ajndk, el kell helyezni egyet
    ; Vletlen szm generlsa a kgy testbl
    ldi xh, KIGYO_H
    ldi xl, KIGYO_L
    ld mari, x
    and mari, rmari
    mov xl, mari
    ld bela, x
    cpi bela, URES
    brne JATEK_TOVABB
    
    ldi bela, KAJA
    st x, bela
    sti AJANDEK_H, AJANDEK_L, 1     ; Ajndk mr van a plyn

    ; Mehet tovbb a jtk  
    JATEK_TOVABB:
    
    call LCD_KIIRAS ; Kirajzolom a memrit az LCD kijelzre  
	
	rcall	delay100ms
	rcall	delay100ms
	rcall	delay100ms
	rcall	delay100ms
	rcall	delay100ms
	call IDOZITO

; Ugorj vissza, mert megy tovbb a jtk
jmp JATEK

;******************************************************************************
;*                                                                            *
;*  A jtk vge                                                              *
;*                                                                            *
;*  Az eredmnyjelzs kirsa s vrakozs a jtk jrakezdsre              *
;*                                                                            *
;******************************************************************************
JATEK_VEGE:

    ; Jtkterlet kitltse
    pushi URES                      ; res karakterrel tlti fel a memrit
    wpushi PALYA_H, PALYA_L + 0     ; Kezdcm H,L bjt
    wpushi PALYA_H, PALYA_L + 132   ; Vgcm H,L bjt
    call MEMORIA_KITOLTES           ; Memria kitltse

    ; Az zenetet lezr 0 bjt
    pushi 0
    
    ; Megszerzett pontokat kirom
    lds mari, PONTOK_H*256+PONTOK_L
    cpi mari, 10    ; Lssuk hogy viszonyul a 10 ponthoz
    brlo KISEBB_10  ; Kevesebb, ugrs

    ; Tbb mint 10 pont, ezrt kt jegyre kell bontani
    clr cecil	    ; Alapbl 0 a 10-es helyirtk
    ldi bela, 10    ; 10-et kell kivonni az magasabb rend taghoz

    ; A jegyeket sztbont programrsz
    TOBBJEGY_FO:
    sub mari, bela          ; Kivonok 10-et
    inc cecil               ; Nvelem a 10-es helyirtket
    cpi mari, 10            ; Lssuk hogy viszonyul most a szm a 10-hez
    brlo TOBBJEGY_KISEBB_10 ; Kisebb, teht maga az alacsony helyirtk, ugrs
    jmp TOBBJEGY_FO         ; Menjnk vissza s vonjunk ki mg belle

    ; Mr egyjegyre redukltam a szmot
    TOBBJEGY_KISEBB_10:
    ldi bela, 48            ; A 0 karakter kdja
    add mari, bela          ; Hozzadom az alacsony helyirtk szmhoz
    push mari               ; Lenyomom a karaktert a stackbe
    add cecil, bela         ; Hozzadom a magasabb helyirtk szmhoz
    push cecil              ; Lenyomom a karaktert a stackbe
    jmp JATEK_VEGE_KIIR     ; Folytatom a jtk vge kirst
    
    ; Kevesebb mint 10 pontot szerzett ezrt 1 szmjegy elg a kirshoz
    KISEBB_10:
    ldi bela, 48        ; A 0 karakter helye
    add mari, bela      ; Hozzadom a szerzett pontot
    push mari           ; A karaktert lenyomom a stackbe az zenet funkcinak

    ; Kirom a jtk vgt
    JATEK_VEGE_KIIR:
    
    pushi URES  ; A pontszm elvlasztshoz
    pushi 'm'
    pushi 'a'
    pushi 'z'
    pushi 's'
    pushi 't'
    pushi 'n'
    pushi 'o'
    pushi 'p'
    pushi 13    ; Soremels
    pushi 'e'
    pushi 'g'
    pushi 'e'
    pushi 'v'
    pushi URES  ; A szveg tagolshoz
    pushi 'k'
    pushi 'e'
    pushi 't'
    pushi 'a'
    pushi 'j'
    pushi VEGE_UZENET_L     ; Az zenet elhelyezkeds a memriban
    pushi VEGE_UZENET_H     ; (cmregiszter)
    call UZENET ; rja ki az zenetet a funkci

    call LCD_KIIRAS     ; Kirajzolom a memrit az LCD kijelzre

    ; Gombok llapotnak alapbelltsa a memriban
    sti GOMB1_H, GOMB1_L, 0
    sti GOMB2_H, GOMB2_L, 0
    sti GOMB3_H, GOMB3_L, 0
    sti GOMB4_H, GOMB4_L, 0

    ; Gombnyomsra vr a vgtelen ciklusban
    JATEK_VAR:
        ; Lssuk az els gombot nyomtk-e meg (azzal lehet jraindtani)
        ldi yh, GOMB1_H     ; GOMB1 sajt trol cmnek belltsa
        ldi yl, GOMB1_L
        ld mari, y          ; Bjt olvassa (gomb llapota)
        cpi mari, 1         ; Be van-e nyomva a gomb
        brne JATEK_VAR      ; Nem, akkor folytasd tovbb az ellenrzst
    
    ; Lenyomtk a gombot, jra lehet kezdeni a jtkot
    jmp RESET

;*** FUNKCIK ***
    
;******************************************************************************
;*                                                                            *
;*  Memria kitlts                                                          *
;*  A memria megfelel rekeszeit alaprtkre lltja                         *
;*                                                                            *
;*  Paramterek (STACK)                                                       *
;*      Kitlt bjt    - mivel legyen a memria kitltve                     *
;*      Kezdcm        - a kitlts kezdcme (H bjt)                       *
;*      Kezdcm        - a kitlts kezdcme (L bjt)                       *
;*      Vgcm          - a kitlts vgnek a cme (H bjt)                  *
;*      Vgcm          - a kitlts vgnek a cme (L bjt)                  *
;*                                                                            *
;*  rintett regiszterek                                                      *
;*  X,Y,Z,mari                                                                *
;*                                                                            *
;******************************************************************************
MEMORIA_KITOLTES:
    ; A visszaugrshoz trolom a cmeket
    pop zl
    pop zh

    ; A funkci paramtereit kiveszem a stackbl
    pop xl  ; Cmregiszter, eddig kell kitlteni
    pop xh
    pop yl  ; Cmregiszter, innen kell kitlteni
    pop yh
    pop mari
    
    ; Memria kitltst vgz f programrsz
    MEM_K_FO:
        cp yl, xl           ; Kell-e mg tlteni az als bjt szerint
        brne MEM_K_TOVABB   ; Igen, ugorj tovbb
        cp yh, xh           ; Nem, ezrt ellenrizd a fels bjtot is
        breq MEM_K_KILEP    ; A fels bjt szerint sem kell, lpj ki

        ; Mehet tovbb, a memria kitlts
        MEM_K_TOVABB:
        st y+, mari ; Memriba rok s nvelem a cmz regisztert
    
    ; Folytatom a ciklust
    jmp MEM_K_FO
    
    ; Ki lehet lpni
    MEM_K_KILEP: 
    ; Visszalltom az ugrshoz szksges cmet
    push zh
    push zl
    ret ; Visszatrs

;******************************************************************************
;*                                                                            *
;*  zenet kirsa                                                            *
;*  Kirja az zenetet a memriba                                            *
;*                                                                            *
;*  Paramterek (STACK)                                                       *
;*      0               - 0 bjt (zr karakter)                              *
;*      Karakter        - kirand karakterek                                 *
;*          ...                                                               *
;*      Hova rjam      - a kirs kezdetnek a cme a memriban (H bjt)    *
;*      Hova rjam      - a kirs kezdetnek a cme a memriban (L bjt)    *
;*                                                                            *
;*  rintett regiszterek                                                      *
;*  Y,Z,mari,bela,cecil                                                       *
;*                                                                            *
;******************************************************************************
UZENET:
    ; A visszaugrshoz trolom a cmeket
    pop zl
    pop zh

    ; Trolom a cmregiszterbe hogy hova kell kirni
    pop mari
    mov yh, mari
    pop cecil       ; A cecil regiszterre mg a soremelsnl szksg lesz
    mov yl, cecil

    ; Az zenet kirsa
    UZENET_FO:
        pop mari            ; Karakter kihzsa a stackbl
        cpi mari, 13        ; Lssuk hogy soremels-e
        brne U_FO_TOVABB    ; Nem, ezrt tovbb ugrunk
    
        ; Soremels jtt
        ldi bela, 22        ; Ennyit kell ugorni a memriban
        add cecil, bela     ; Emeljk a cecilt
        mov yl, cecil       ; j koordintk a cmregiszterben
        jmp UZENET_FO       ; Olvassuk tovbb a karaktereket, ugrs

        ; Nem soremels jtt, hagyomnyos karakter
        U_FO_TOVABB:
        cpi mari, 0         ; Lssuk hogy 0 bjt-e azaz a zr karakter
        breq UZENET_KILEP   ; Igen, ezrt ki lehet lpni
        st y+, mari         ; Nem, rjuk a memriba s nveljk a cmregiszert
        jmp UZENET_FO       ; Folytassuk a beolvasst

    UZENET_KILEP:
    ; A visszaugrshoz visszalltom a cmeket
    push zh
    push zl
    ret ; Visszaugrs

;******************************************************************************
;*                                                                            *
;*  LCD kirs                                                                *
;*  Kirja a memrit az LCD kijelzre                                        *
;*                                                                            *
;******************************************************************************
LCD_KIIRAS:
    ; Memria bizonyos rszeit az LCD kijelzre kell rni
    ; TODO
	push mari
	push bela
	push cecil
	push yh
	push yl

	ldi yh, PALYA_H
	ldi yl, PALYA_L+23
	ldi mari, 0

    LCD_KIIRAS_1:
		mov LCD_X, mari
		ldi LCD_Y, 0
		rcall LCD_GotoXY
		ld DataReg, y 	
		inc mari
		inc yl
		rcall LCD_Data
		cpi mari, 20
	brne LCD_KIIRAS_1 
	
	ldi mari, 0
	inc yl
	inc yl
	
    LCD_KIIRAS_2:
		mov LCD_X, mari
		ldi LCD_Y, 1
		rcall LCD_GotoXY
		ld DataReg, y 	
		inc mari
		inc yl
		rcall LCD_Data
		cpi mari, 20
	brne LCD_KIIRAS_2 

	ldi mari, 0
	inc yl
	inc yl
	
    LCD_KIIRAS_3:
		mov LCD_X, mari
		ldi LCD_Y, 2
		rcall LCD_GotoXY
		ld DataReg, y 	
		inc mari
		inc yl
		rcall LCD_Data
		cpi mari, 20
	brne LCD_KIIRAS_3

	ldi mari, 0	
	inc yl
	inc yl

    LCD_KIIRAS_4:
		mov LCD_X, mari
		ldi LCD_Y, 3
		rcall LCD_GotoXY
		ld DataReg, y 	
		inc mari
		inc yl
		rcall LCD_Data
		cpi mari, 20
	brne LCD_KIIRAS_4 

	pop yl
	pop yh
	pop cecil
	pop bela
	pop mari
ret

;******************************************************************************
;*                                                                            *
;*  Idzt                                                                   *
;*  Megszakts, ami belltja az irnyt, majd trli a gombok llapott       *
;*  azutn pedig kgy lptetst kr                                          *
;*                                                                            *
;******************************************************************************
IDOZITO:
    ; Megszakts kezels plussz
    ; TODO

    ; Cmregiszter mentse
    mov ibela, yh
    mov icecil, yl

    ; Lssuk az els gombot nyomtk-e meg
    ldi yh, GOMB1_H     ; GOMB1 sajt trol cmnek belltsa
    ldi yl, GOMB1_L
    ld imari, y         ; Bjt olvassa (gomb llapota)
    cpi imari, 1        ; Be van-e nyomva a gomb
    breq IDOZITO_GOMB1  ; Igen, ugorj az els gomb lenyoms kdra

    ; Lssuk a msodik gombot nyomtk-e meg
    ldi yh, GOMB2_H     ; GOMB2 sajt trol cmnek belltsa
    ldi yl, GOMB2_L
    ld imari, y         ; Bjt olvassa (gomb llapota)
    cpi imari, 1        ; Be van-e nyomva a gomb
    breq IDOZITO_GOMB2  ; Igen, ugorj a msodik gomb lenyoms kdra

    ; Lssuk a harmadik gombot nyomtk-e meg
    ldi yh, GOMB3_H     ; GOMB3 sajt trol cmnek belltsa
    ldi yl, GOMB3_L
    ld imari, y         ; Bjt olvassa (gomb llapota)
    cpi imari, 1        ; Be van-e nyomva a gomb
    breq IDOZITO_GOMB3  ; Igen, ugorj a harmadik gomb lenyoms kdra

    ; Lssuk a negyedik gombot nyomtk-e meg
    ldi yh, GOMB4_H     ; GOMB4 sajt trol cmnek belltsa
    ldi yl, GOMB4_L
    ld imari, y         ; Bjt olvassa (gomb llapota)
    cpi imari, 1        ; Be van-e nyomva a gomb
    breq IDOZITO_GOMB4  ; Igen, ugorj a nyegyedik gomb lenyoms kdra

    ; Nincs lenyomva gomb, hagyd meg az irnyt
    jmp IDOZITO_VEGE

    IDOZITO_GOMB1:
    ldi yh, IRANY_H     ; Cmregiszter az irnyra mutassan
    ldi yl, IRANY_L
    ldi imari, 3        ; Bal fele (3) megy az 1-es gomb
    st y, imari         ; Trols a memriba
    jmp IDOZITO_VEGE    ; Vge az idztsnek

    IDOZITO_GOMB2:
    ldi yh, IRANY_H     ; Cmregiszter az irnyra mutassan
    ldi yl, IRANY_L
    ldi imari, 1        ; Jobb fele (1) megy a 2-es gomb
    st y, imari         ; Trols a memriba
    jmp IDOZITO_VEGE    ; Vge az idztsnek

    IDOZITO_GOMB3:
    ldi yh, IRANY_H     ; Cmregiszter az irnyra mutassan
    ldi yl, IRANY_L
    ldi imari, 2        ; Lefele (2) megy a 3-es gomb
    st y, imari         ; Trols a memriba
    jmp IDOZITO_VEGE    ; Vge az idztsnek

    IDOZITO_GOMB4:
    ldi yh, IRANY_H     ; Cmregiszter az irnyra mutassan
    ldi yl, IRANY_L
    ldi imari, 4        ; Fel fele (4) megy a 4-es gomb
    st y, imari         ; Trols a memriba
    jmp IDOZITO_VEGE    ; Vge az idztsnek

    ; Vge az idztsnek
    IDOZITO_VEGE:
    ; Cmregiszter visszalltsa
    mov yh, ibela   
    mov yl, icecil

    ; Gombok llapotnak alapbelltsa a memriban
    stii GOMB1_H, GOMB1_L, 0
    stii GOMB2_H, GOMB2_L, 0
    stii GOMB3_H, GOMB3_L, 0
    stii GOMB4_H, GOMB4_L, 0
    ret    ; Trj vissza s lltsd vissza a megszaktst


;*******************************************************************************
;*                                                                             *
;*  Gombok megszaktsai                                                       *
;*  Belltjk sajt memria cmkn a bjtot, csak lenyomsra                 *
;*                                                                             *
;*******************************************************************************
GOMB1:
    ; Megszakts kezels plussz
    ; TODO

    ; Gombok llapotainak belltsa a memribam
    stii GOMB1_H, GOMB1_L, 1
    stii GOMB2_H, GOMB2_L, 0
    stii GOMB3_H, GOMB3_L, 0
    stii GOMB4_H, GOMB4_L, 0
    reti    ; Trj vissza s lltsd vissza a megszaktst
GOMB2:

    ; Gombok llapotainak belltsa a memribam
    stii GOMB1_H, GOMB1_L, 0
    stii GOMB2_H, GOMB2_L, 1
    stii GOMB3_H, GOMB3_L, 0
    stii GOMB4_H, GOMB4_L, 0
    reti    ; Trj vissza s lltsd vissza a megszaktst
GOMB3:
	nop
    ; Gombok llapotainak belltsa a memribam
    stii GOMB1_H, GOMB1_L, 0
    stii GOMB2_H, GOMB2_L, 0
    stii GOMB3_H, GOMB3_L, 1
    stii GOMB4_H, GOMB4_L, 0
	reti    ; Trj vissza s lltsd vissza a megszaktst
GOMB4:

    ; Gombok llapotainak belltsa a memribam
    stii GOMB1_H, GOMB1_L, 0
    stii GOMB2_H, GOMB2_L, 0
    stii GOMB3_H, GOMB3_L, 0
    stii GOMB4_H, GOMB4_L, 1
    reti    ; Trj vissza s lltsd vissza a megszaktst

dummy:
reti


;********************************************************
;****
;**** write ASCII char to LCD and execute control char
;****
;********************************************************

LCD_Write_Chr:

	cpi	DataReg,0x1f
	brcs	CTRLchr		;char is control char
	jmp	WriteLCD	;char is ASCII

CTRLchr:
	cpi	DataReg,1	;Check for a Cursor Home (CTLR-A ASCII 1)
	brne	Check_LCD_On
	Call	LCD_Home
	ret

Check_LCD_On:
	cpi	DataReg,2	;Check for a LCD_On  (CTLR-B ASCII 2)
	brne	Check_LCD_Off
	Call	LCD_On
	ret

Check_LCD_Off:
	cpi	DataReg,3	;Check for a LCD_Off  (CTLR-C ASCII 3)
	brne	Check_HideCursor
	Call	LCD_Off		;Call the macro 
	ret

Check_HideCursor:
	cpi	DataReg,4	;Check for Hide Cursor (CTRL-D ASCII 4)
	brne	Check_UnderlineCursor
	call	LCD_CursorOff
	ret 

Check_UnderLineCursor:
	cpi	DataReg,5	;Check for Underline Cursor (CTRL-E ASCII 5)
	brne	Check_BlinkingBlockCursor
	call	LCD_CursorOn	;Turn cursor ON
	ret 

Check_BlinkingBlockCursor:
	cpi	DataReg,6	;Check for Blinking Block Cursor (CTRL-F ASCII 6)
	brne	Check_Bell
	call	LCD_BlinkOn	;Make the cursor blink
	ret 

Check_Bell:
;	cpi	DataReg,7	;Check for a Bell (CTRL-G ASCII 7)
;	brne	Check_BackSpace
;	ret	;Do nothing as we do not have an piezo buzzer

Check_BackSpace:
	cpi	DataReg,8	;Check for BackSpace (CTRL-H ASCII 8)
	brne	Check_VerticalTab

	cpi	LCD_X,0
	brne	Dec_X
	ldi	Datareg,0x20 
	rcall	LCD_Data
	dec	LCD_X
	rcall	LCD_GotoXY 
	ret
Dec_X:
	dec	Lcd_X
	rcall	LCD_GotoXY
	ldi	DataReg,0x20
	rcall	LCD_Data
	dec	Lcd_X
	rcall	LCD_GotoXY
	ret

Check_VerticalTab:		;Check for Vertical Tab Up (CTRL-K ASCII 11)
	cpi	DataReg,0x0b
	brne	Check_ClearScreen
	cpi	LCD_Y,0 
	brne	Cont_VerticalTab
	ret

Cont_VerticalTab:
	dec	LCD_Y
	call	LCD_GotoXY
	ret

Check_ClearScreen:		;Check for Clear Screen (CTRL-L ASCII 12)
	cpi	DataReg,0x0c
	brne	Check_LF
	call	LCD_Cls 
	ret
Check_LF:			;Check for LF (CTRL-J ASCII 13)
	cpi	DataReg,0x0a
	brne	Check_CarriageReturn
	jmp	LF


Check_CarriageReturn:		;Check for CR (CTRL-M ASCII 13)
	cpi	DataReg,0x0d
	brne	Check_BlinkOff
	cpi	LCD_Y,NoOflines-1
	brne	CarriageReturn_Cont
	ldi	LCD_Y,0xff

CarriageReturn_Cont:
	ldi	LCD_X,0
LF:	inc	LCD_Y
	rcall	LCD_GOTOXY
	ret

Check_BlinkOff:			;LCD_BlinkOff (CTRL-N ASCII 14)
	cpi	DataReg,0x0e
	brne	Check_LCD_ShiftDisplayR
	call	LCD_BlinkOff
	ret
	
Check_LCD_ShiftDisplayR:
	cpi	DataReg,0x0f	;LCD_ShiftDisplayR (CTRL-O ASCII 15)
	brne	Check_LCD_ShiftDisplayL
	call	LCD_ShiftDisplayR
	ret
Check_LCD_ShiftDisplayL:
	cpi	DataReg,0x10	;LCD_ShiftDisplayL (CTRL-P ASCII 16)
	brne	Check_LCD_ShiftCursorR
	call	LCD_ShiftDisplayL
	ret

Check_LCD_ShiftCursorR:		;LCD_ShiftCursorR (CTRL-Q ASCII 17)
	cpi	DataReg,0x11
	brne	Check_LCD_ShiftCursorL
	call	LCD_ShiftCursorR
	ret

Check_LCD_ShiftCursorL:		;LCD_ShiftCursorL (CTRL-R ASCII 18)
	cpi	DataReg,0x12
	brne	Check_delay
	call	LCD_ShiftCursorL
	ret

Check_delay:		;delay 100msec (CTRL-S ASCII 19)
	cpi	DataReg,0x13
	brne	Check_delay1
	call	delay100ms
	ret
Check_delay1:		;delay 1sec (CTRL-S ASCII 20)
	cpi	DataReg,0x14
	brne	WriteLCD
	call	delay1s
	ret

WriteLCD:
	rcall	LCD_Data 
	;rcall	Uart_Putchar	;echoing back the received char 
Noexit:
	ret

;*********************************************************************
;****
;**** write char to Lcd, check/modify cursor position if line end
;****
;*********************************************************************
LCD_Data:

	mov	wreg,DataReg
	andi	wreg,0x0F0
	out	PORTA,wreg
	sbi	PortA,lcdrs
	rcall	LCD_EPULSE
	mov	wreg,DataReg
	swap	wreg
	andi	wreg,0x0F0
	out	PORTA,wreg
	sbi	PortA,lcdrs	;
	rcall	LCD_EPULSE
	rcall	Delay40us
	inc	LCD_X


	cpi	LCD_X,LineLength ;Check if we are at the last Xpos
	brne	Lcd_Write_Exit  ;no change LCD_Y

	ldi imari, 0
	cp	Line_Wrap,imari	;Check if Line wrap is on or off
	breq	Lcd_Write_Exit  ;no change LCD_Y,No line wrap

	ldi	LCD_X,0		;Point at the first row X

	cpi	LCD_Y,NoOfLines-1 ;check if we are at the last line of the lcd
	brne	Lcd_Write_NextLine ;If we are not move to the next line
	ldi	LCD_Y,0
	rcall	LCD_Gotoxy
	rjmp	Lcd_Write_Exit 

Lcd_Write_NextLine:
	inc	Lcd_Y
	rcall	LCD_Gotoxy 

Lcd_Write_Exit:
	ret 


;********************
;****
;****	Lcd Init
;****
;********************
Lcd_Init:
	rcall	Delay1s	; Wait approx 1 sec
;first 3*8bit mode and 1*4bit mode, then real programming
	cbi	PortA,lcdrs	;Clear RS

	ldi	Wreg,0x30	;8bit mode
	out	PORTA,Wreg 
	rcall	LCD_EPulse
	rcall	Delay4ms	; ;Wait 4ms

	ldi	Wreg,0x30	;8bit mode
	out	PORTA,Wreg 
	rcall	LCD_EPulse
	rcall	Delay4ms	; ;Wait 4ms

	ldi	Wreg,0x30	;8bit mode
	out	PORTA,Wreg 
	rcall	LCD_EPulse
	rcall	Delay4ms	; ;Wait 4ms


	ldi	Wreg,0x20	;4bit mode
	out	PORTA,Wreg 
	rcall	LCD_EPulse
	rcall	Delay4ms	; ;Wait 4ms



	ldi	CmdReg,0x28	;4bit mode real
	rcall	LCD_Command
	rcall	Delay4ms	; ;Wait 4ms


	
	ldi	CmdReg,0x4	;entry mode set
	rcall	LCD_Command
;	rcall	Delay4ms	; ;Wait 4ms
	
	
	ldi	CmdReg,0xe	;display on
	rcall	LCD_Command
;	rcall	Delay4ms	; ;Wait 4ms

	ldi	CmdReg,0x1	;Clear Display
	rcall	LCD_Command
	rcall	Delay4ms	; ;Wait 4ms

	clr	LCD_X		;Init the positioning values 
	clr	LCD_Y
	ret

;**************************
;****
;**** Delay 40 mikrosec
;****
;**************************
Delay40us:
	ldi	wreg,0x8e
Loopx:	dec	wreg
	brne	loopx 
	ret
;**************************
;****
;**** Delay 100 mikrosec
;****
;**************************
Delay100us:
	ldi	wreg,0xd8
Loop:	nop
	nop
	dec	wreg
	brne	loop 
	ret
;**************************
;****
;**** Delay 4 milisec
;****
;**************************
Delay4ms:
	ldi	tmp1,0x39 ;OK
Loop1:	ldi	wreg,0x00
Loop2:	dec	wreg
	brne	loop2 
	dec	tmp1
	brne	loop1
	ret
;**************************
;****
;**** Delay 1 sec
;****
;**************************
Delay1s:
	ldi	tmp2,250	; Delay for about 1 sec for the LCD to start
Longdelay_Loop:
	rcall	delay4ms
	dec	tmp2
	brne	LongDelay_Loop
	ret

;**************************
;****
;**** Delay 100msec
;****
;**************************
Delay100ms:
	ldi	tmp2,25	; Delay for about 1 sec for the LCD to start
	rjmp	Longdelay_Loop

;********************************************
;****
;**** write CmdReg to LCD control register
;****
;********************************************
LCD_Command:
	cbi	PortA,lcdrs
	mov	wreg,CmdReg
	andi	wreg,0xF0
	out	PortA,wreg			;out high nibble
	rcall	LCD_EPULSE
	swap	CmdReg
	andi	CmdReg,0xF0
	out	PortA,CmdReg	;out low nibble
	rcall	LCD_EPULSE
	rcall	Delay40us
	ret 

;**************************************************
;**** 
;**** LCD_GotoXY set cursor position LCD_X, LCD_Y
;**** 
;**************************************************
LCD_GotoXY:

	ldi	CmdReg,FirstLine_Add
	cpi	LCD_Y,0	;Check to see which line
	breq	Calc_X
	ldi	CmdReg,SecondLine_Add
	cpi	LCD_Y,1	;Check to see which line
	breq	Calc_X
	ldi	CmdReg,ThirdLine_Add
	cpi	LCD_Y,2	;Check to see which line
	breq	Calc_X
	ldi	CmdReg,FourthLine_Add
	cpi	LCD_Y,3	;Check to see which line
	breq	Calc_X
	


Calc_X:
	add	CmdReg,LCD_X
	rcall	LCD_Command    ;Set DDRam Add
	rcall	Delay40us
	ret


;***************************
;****
;**** Lcd enable pin pulse
;****
;***************************
LCD_EPulse:
	sbi	PortA,lcden	;E high
	nop
	nop
	nop
	nop
	cbi	PortA,lcden	;E Low
	ret

;********************************
;****
;**** Lcd control subrutines
;****
;********************************


LCD_Cls:
	ldi	CmdReg,0b00000001
	rcall	LCD_Command 
	rcall	delay4ms
	ldi	LCD_X,0
	ldi	LCD_Y,0 
	ret

LCD_Home:
	ldi	CmdReg,0b00000010
	rcall	LCD_Command 
	rcall	delay4ms
	clr	LCD_X
	clr	LCD_Y
	ret

LCD_On:
	ldi	CmdReg,0b00001100
	rcall	LCD_Command 
;	rcall	delay40us
	ret

LCD_Off:
	ldi	CmdReg,0b00001000
	rcall	LCD_Command 
;	rcall	delay40us
	ret

LCD_CursorOn:
	ldi	CmdReg,0b00001110
	rcall	LCD_Command 
;	rcall	delay40us
	ret

LCD_CursorOff:
	ldi	CmdReg,0b00001100
	rcall	LCD_Command 
;	rcall	delay40us
	ret
LCD_BlinkOn:
	ldi	CmdReg,0b00001111
	rcall	LCD_Command 
;	rcall	delay40us
	ret
LCD_BlinkOff:
	ldi	CmdReg,0b00001110
	rcall	LCD_Command 
;	rcall	delay40us
	ret
LCD_ShiftCursorL:
	ldi	CmdReg,0b00010000
	rcall	LCD_Command 
;	rcall	delay40us 
	ret
LCD_ShiftCursorR:
	ldi	CmdReg,0b00010100
	rcall	LCD_Command 
;	rcall	delay40us 
	ret

LCD_ShiftDisplayL:
	ldi	CmdReg,0b00011000
	rcall	LCD_Command 
;	rcall	delay40us 
	ret
LCD_ShiftDisplayR:
	ldi	CmdReg,0b00011100
	rcall	LCD_Command 
;	rcall	delay40us 
	ret



;*******************************************************
;****
;**** write string to LCD from Eeprom (EEAR pointer)
;****
;*******************************************************
LCD_Eeprom_str:
	rcall	EERead_seq	;get EEPROM data
;	mov	wreg,EE_dat
	cpi	wreg,0		;Check if we have reached the End of string
	breq	LCD_str_End
;	mov	DataReg,EE_dat
	rcall	LCD_Write_chr
	rjmp	LCD_Eeprom_str 

LCD_str_End:
	ret



;**************************************************************
;**** 
;**** reads the EEPROM into the register variable "EE_dat".
;**** increments the address, stored in EEARL
;****
;**************************************************************
EERead_seq:
	sbi	EECR,EERE	;set EEPROM Read strobe
;This instruction takes 4 clock cycles since
;it halts the CPU for two clock cycles
	sbi	EECR,EERE	;set EEPROM Read strobe 2nd time
;This instruction takes 4 clock cycles since
;it halts the CPU for two clock cycles
;	in	EE_dat,EEDR	;get data
	in	wreg,EEARL	;get address
	inc	wreg		;increment address
	out	EEARL,wreg	;store it 
	ret


;************************************************************
;****
;**** write string to LCD from Flash (Z register pointer)
;****
;************************************************************

LCD_Flash_str:
	lpm	DataReg,Z+                     ; Load constant from program
	cpi	DataReg,0		;Check if we have reached the End of string
	breq	LCD_str_End
	rcall	LCD_Write_chr
	rjmp	LCD_Flash_str

;*********************************************************************
;****
;**** Delayed write string to LCD from Flash (Z register pointer)
;****
;*********************************************************************

LCD_Delay_Flash_str:
	lpm	DataReg,Z+                     ; Load constant from program
	cpi	DataReg,0		;Check if we have reached the End of string
	breq	LCD_str_End
	rcall	LCD_Write_chr
	rcall	Delay100ms
	in	wreg,pinc
	com	wreg		;negate
	out	portc,wreg
	rjmp	LCD_Delay_Flash_str
